#include <stdio.h>
#include <string.h>

int main (int argc, char *argv[]) {

  int i, j;
  int lc;
  double **values;
  FILE *fp;

  if (argc < 3) {

    printf ("Usage: average lc filenames\n");
    exit (1);

  }

  printf ("OUTPUT FROM AVERAGE: \n");
  for (i=0;i<argc;i++)
    printf ("%d: %s\n", i, argv[i]);
  lc = atoi (argv[1]);

  values = (double **) malloc ((argc - 1) * sizeof (double *));

  if (!values) {

    fprintf (stderr, "Out of memory\n");
    exit (3);

  }

  for (i = 2; i < argc; i++) {

    fp = fopen (argv [i], "r");

    if (!fp) {

      fprintf (stderr, "Could not open file %s\n", argv [i]);
      exit (2);

    }

    values [i - 2] = (double *) malloc (lc * sizeof (double));

    if (!values) {
      
      fprintf (stderr, "Out of memory\n");
      exit (3);

    }

    for (j = 0; j < lc; j++)
      fscanf (fp, "%lf", &values[i - 2][j]);

    fclose (fp);

  }

  values [argc - 2] = (double *) malloc (lc * sizeof (double));

  if (!values) {
      
    fprintf (stderr, "Out of memory\n");
    exit (3);

  }

  bzero (values [argc - 2], lc * sizeof (double));

  for (j = 0; j < lc; j++) {

    for (i = 0; i < argc - 2; i++)
      values [argc - 2][j] += values [i][j];

    values [argc - 2][j] /= (argc - 2);

  }

  for (j = 0; j < lc; j++)
    printf ("%lf\n", values [argc - 2][j]);

  exit (0);

}
